// --------------------------------------------------------------------
// Projet POBOT Carte CNP.     		                             			---
// Fonctions de Gestion du Terminal PC. Version 1.0.                ---
//                                                                  ---
// Cr le 01 Fvrier 2006 par Spinelli Gilles.                     ---
//																																	---
// --------------------------------------------------------------------

#include "CarteCNP.h"


// --- Initialisation Terminal. ---
void Terminal_Init(void)
{
	Serial_Init(SERIAL_V19200);										// Eventuellement Re-Initialise Liaison Srie.
	Serial_InitRec(FRAME_STOP_TIMEOUT,SERIAL_DEFAULT_TIMEOUT);  // Initialise Rception (pour ScanChar).
}


// --- Envoi Position Curseur ---
void PosCur(unsigned char cPosX, unsigned char cPosY) 
{
    strcpy(szSerial_BufferSend,CURSOR_POSITION);
    szSerial_BufferSend[2] = (cPosY/10) + '0';
    szSerial_BufferSend[3] = (cPosY%10) + '0';
    szSerial_BufferSend[5] = (cPosX/10) + '0';
    szSerial_BufferSend[6] = (cPosX%10) + '0';
    Serial_Send(strlen(szSerial_BufferSend));
    while (!bSerial_EndSend) { }
}


// --- Envoi Effacement Ecran ---
void ClearScreen(void) 
{
    strcpy(szSerial_BufferSend,CLEAR_SCREEN);
    Serial_Send(strlen(szSerial_BufferSend));
    while (!bSerial_EndSend) { }
		PosCur(1, 1);
}


// --- Envoi Effacement Ligne ---
void ClearLine(unsigned char cLine) 
{
    PosCur(1,cLine);
    strcpy(szSerial_BufferSend,CLEAR_LINE);
    Serial_Send(strlen(szSerial_BufferSend));
    while (!bSerial_EndSend) { }
}


// --- Attend l'arrive d'un caractre et le retourne ---
unsigned char ReadChar(void)
{
	unsigned char	cCar;
	
	Serial_InitRec(FRAME_STOP_TIMEOUT,SERIAL_DEFAULT_TIMEOUT);
	while (!bSerial_BeginRec && !bSerial_EndRec) { }
	cCar=szSerial_BufferRec[0];
	Serial_InitRec(FRAME_STOP_TIMEOUT,SERIAL_DEFAULT_TIMEOUT);
	return(cCar);
}


// --- Teste si un caractre est arriv et le retourne ---
unsigned char ScanChar(void)
{
	unsigned char cCar = 0x00;
	
	if (bSerial_BeginRec && bSerial_EndRec)
	{
		cCar=szSerial_BufferRec[0];
		Serial_InitRec(FRAME_STOP_TIMEOUT,SERIAL_DEFAULT_TIMEOUT);
	}
	return(cCar);
}


// --- Envoi une chaine de caractre sur la liaison Srie ---
void PrintS(unsigned char * szMessage)
{
	strcpy(szSerial_BufferSend,szMessage);
	Serial_Send(strlen(szSerial_BufferSend));
	while (!bSerial_EndSend) { }
}
